package ru.dbotthepony.mc.otm.android;

import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.TranslatableComponent;
import net.minecraftforge.registries.*;
import ru.dbotthepony.mc.otm.capability.IAndroidCapability;

import javax.annotation.Nullable;

public class AndroidFeatureType<T extends AndroidFeature> extends ForgeRegistryEntry<AndroidFeatureType<?>> {
	public interface AndroidFeatureFactory<T extends AndroidFeature> {
		T factory(AndroidFeatureType<T> entry, IAndroidCapability capability);
	}

	protected final AndroidFeatureFactory<T> factory;

	public AndroidFeatureType(AndroidFeatureFactory<T> factory) {
		this.factory = factory;
	}

	public T factory(IAndroidCapability capability) {
		return factory.factory(this, capability);
	}

	public boolean isApplicable(IAndroidCapability capability) {
		return true;
	}

	public Component getDisplayName() {
		if (getRegistryName() == null)
			return new TranslatableComponent("android_feature.null.null");

		return new TranslatableComponent("android_feature." + getRegistryName().getNamespace() + "." + getRegistryName().getPath());
	}
}
