package ru.dbotthepony.mc.otm.screen.panels;

import net.minecraft.client.gui.components.Button;
import net.minecraft.network.chat.Component;
import ru.dbotthepony.mc.otm.screen.MatteryScreen;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class ButtonPanel extends MinecraftWidgetPanel<Button> {
	protected Runnable press_callback;

	public ButtonPanel(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y, float width, float height, Component label) {
		super(screen, parent, x, y, width, height, (panel) -> {
			return new Button(0, 0, (int) panel.getWidth(), Math.min(20, (int) panel.getHeight()), label, (btn) -> ((ButtonPanel) panel).onPress()) {
				@Override
				public boolean isHovered() {
					return panel.is_hovered;
				}
			};
		});
	}

	public void bindOnPress(Runnable runnable) {
		press_callback = runnable;
	}

	protected void onPress() {
		if (press_callback != null) {
			press_callback.run();
		}
	}
}
